/* suckhtml.java
 * Copyright (C) 2018,2019 Momi-g
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 */


// rebuild:	javac (-target 1.5 -source 1.5) *.java
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.StringReader;

import java.util.ArrayList;
import java.util.LinkedHashMap;

import javax.swing.text.html.parser.ParserDelegator;


//シェルコマンド系の実装
//メソッドのみ。

//java suckhtml -c @text -p content 1-c @sound -p src 1 -c @num -c 1`
//-comment を出力
//htmlを解析して-property が'content'であるもののうち '1'番目に出てきたものを表示
//あと追加コメント。@numとか。

public class suckhtml {
	public static void main(String[] args) {
		/*
				StringBuffer output_s = new StringBuffer();
				StringBuffer input_s = new StringBuffer();
				BufferedReader br =
				    new BufferedReader(new InputStreamReader(System.in));
				String line;
				try {
					while ( (line = br.readLine()) != null) { // ユーザの一行入力を待つ
						System.out.println(line);
						input_s.append(line);
					}
					br.close();
					System.out.println(input_s);
					StringReader rdstr = new StringReader(new String(input_s) );
		*/
		//System.out.println(args[0]);
		if(args.length == 0 || args[0].equals("-h") ) {
			System.out.println("" +
			                   "HowTo (suckhtml, html parse pg) \n"+
			                   "opt: -h, -t(ag), -T(ag, all), -p(roperty), -P(p, all) \n"+
			                   "     -c(omment) -X(teXt, all plaintext) \n"+
			                   "------ \n"+
			                   "ex.) wget www.wikipedia.org -O - > buf.html (...raw html text) \n" +
			                   "	~$ cat buf.html | java suckhtml -X	>> (plain text, del tags)	\n" +
			                   "								\n" +
			                   "ex.) ..| java suckhtml -T or P >> (disp all tags/properties + count + data) \n" +
			                   "	HREF 26 [aaa, bbb]...etc. '-T' deletes '\\n' char for one liner.\n" +
			                   "									\n" +
			                   "ex.) ..| java suckhtml -p src 1   >> show first 'src' property holding data\n"+
			                   "	http://aa.bb.cc   ...etc \n" +
			                   "								\n" +
			                   "ex.) ..| java suckhtml -t META 3  >> show third 'meta' tag holding data(all) \n" +
			                   "	<meta http-equiv='content-style-type' content='text/css' />    >>> \n" +
			                   "	http-equiv=content-style-type content=text/css   ...etc \n" +
			                   "								\n" +
			                   "ex.) ..| java suckhtml -c 'comment_unko'	>> (print your comment) \n" +
			                   "								\n" +
			                   "ex.) ..| java suckhtml -c 'comm1'   -p src 1   -c 'comm2'	\n" +
			                   "	 >> 'comm1' / http... / 'comm2'	\n" +
			                   "...this pg works only at pipe input. (/dev/stdin) \n" +
			                   "rebuild:	javac (-target 1.5 -source 1.5 or upper) *.java" +
			                   "");
			return;
		}

		//	Mycb, htmlをパースした結果のデータ群どもが入ってる。parser_callback
		Mycb cb = new Mycb();	//バッファ無制限 -> new Mycb(100) バッファ100KB
		try {
			BufferedReader rdstr =
			    new BufferedReader(new InputStreamReader(System.in));
			ParserDelegator pd = new ParserDelegator();
			//Mycb cb = new Mycb();
			pd.parse(rdstr, cb, true);
			rdstr.close();

		} catch (Exception e) {
			e.printStackTrace();
			System.err.println("io.err");
			return;
		}

		for(int i=0; i<args.length; i++) {
			if(args[i].equals("-X") ) {
				System.out.println( cb.getplain() );
				continue;
			}
			
			//	-p meta 2 とか
			if(args[i].equals("-t") || args[i].equals("-p") ) {
				ArrayList<String> buf= new ArrayList<String>();

				if (args[i].equals("-t")) {
					buf = cb.get_tag(args[i+1]);
				} else {
					buf = cb.get_prp(args[i+1]);
				}
				int n= Integer.parseInt(args[i+2] ) - 1;	// arr[0]
				System.out.println(buf.get(n));
				//output.append(buf);
				continue;
			}

//	http://www.ne.jp/asahi/hishidama/home/tech/java/string.html#StringBuilder
//	stringbufは初期メモリ量を指定しなくても、オーバーしたら勝手に追加してくれるが
//	syscallのオーバーヘッドがかかるので、あらかじめ大量に必要なのが分かってるなら指定した
//	方がよい。もちろん、その後で超過してもvmが勝手に確保してくれるのでデメリットは無い。
			if(args[i].equals("-T") ) {
				ArrayList<String> buf = cb.get_tags();
				ArrayList<String> lbuf = new ArrayList(0);	// 別に0も()も同じだよ。
				StringBuffer sbuf = new StringBuffer();
				int cnt;	//count

//	要素数カウント結果を追加。どんだけ入ってるかわかんねーから。arrayの要素を調べてるだけ。
// タグは一応情報を一通り表示させる。ただし改行のみ全削除。正確なのはpropで。
//System.out.println(text.replaceAll("[a-z]", "*"));
// javaのリテラルが邪魔で\\nとかかないとダメ。

//	タグリストからタグ名と簡易データ
				for(int ii=0; ii<buf.size(); ii++) {
					sbuf.append(buf.get(ii));
					lbuf=cb.get_tag(buf.get(ii) );
					cnt=lbuf.size();
					System.out.println(sbuf + " " + 
						cnt + " " + lbuf.toString().replaceAll("\\n", "") );	//改行は削除。
					sbuf.delete(0, sbuf.length() );	//	endは-1される。設計が微妙過ぎる。limitとpos系
				}
				//System.out.println(buf.toString() );
				//output.append(buf.toString() );
				continue;
			}

			if(args[i].equals("-P") ) {	//同じ。要素は8進数で全出力
				ArrayList<String> prps = cb.get_prps();
				ArrayList<String> datas = new ArrayList(0);
				StringBuffer outbuf = new StringBuffer();
				int cnt;	//count

//			String buf = "abcde";
//			byte[] bb = buf.getBytes();	// バイト型。javaではbyteもプリミティブ型で数値扱い。
//			for(int i=0; i<bb.length; i++){
//	//			int ii =  bb[i].intValue();
//				// javaではprintfが1.5から使える。intValueはラッパークラス向け。プリミティブは(int)で。
//				// 数値上はマイナスだけど、ちゃんと文字表現が帰ってくる。
//				// つーか、多分内部でビット値を直接読み取ってる。
//				System.err.printf("ck_ %03o", bb[i] );
//			}

				for(int ii=0; ii<prps.size(); ii++) {	// prop種類のつまったリスト
					outbuf.append(prps.get(ii));	// 	prop名取り出し
					datas=cb.get_prp(prps.get(ii) );	// 要素リスト
					cnt=datas.size();

					outbuf.append(" " + cnt);

// String bStr = String.format("%02X", b);
// JAXB1.0 DatatypeConverter は 1.6以上。 DatatypeConverter.printHexBinary(bytes);
// しかも16進数のみ。可用性がない。

					for(int jj=0; jj<cnt; jj++) {
						outbuf.append(" ");
						byte[] bins = datas.get(jj).getBytes();	//要素はstr型だけどbyteに詰め直し

						for(byte bin : bins) {		// for(i=0; i<barr.length ; i++)
							outbuf.append("\134" + String.format("%03o", bin ) );
						}
					}

					System.out.println(outbuf);
					outbuf.delete(0, outbuf.length() );	//	endは-1される。設計が微妙過ぎる。limitとpos系
				}
				continue;
			}

			if(args[i].equals("-c") ) {
				i++;
				System.out.println(args[i] );
				//output.append(buf.toString() );
				continue;
			}
		}
	}
}



/*
 * -u "http...."
--text	-X
--tag "a"	-t a
--tag-all	-T
--propaty "src"	-p src
--propaty-all	-P
の5つ。出力のコマンド順番を組み直し。
*/
